; Programa original escrito por Byon Garrabant, N6BG, 
; Modificado por A.Navarro EA3CNO, Julio 2002
; Transmisin de datos con placa Pic-M
; Para modem TCM3105 por EB1BDM
; MODIFICAR EL FICHERO options.asm con tus datos. antes de compilar.
;_________________________________________________________
	LIST	P=PIC16F628A
	include	"P16F628A.INC"
	

         __CONFIG _CP_OFF & _WDT_OFF & _BODEN_ON & _PWRTE_ON & _HS_OSC & _MCLRE_ON & _LVP_OFF 

;_BODEN_ON Activado el reset por bajada de tension 
;_PWRTE_ON Pequeo retardo al inicio de conectar la alimentacion, para permitir que la tension se estabilice. 
;_LVP_OFF RB4 actua como pin de entrada/salida 
;_MCLRE_ON El pin de reset RA5/MCLR actua como tal 
;MCLR: Master Clear (Reset). Si el nivel lgico de este terminal es bajo (0 Vcc), el microcontrolador 
;permanece inactivo. Este Reset se controla mediante la palabra de configuracin del PIC.

;_________________________________________________________
	cblock	H'20'		; variables del sistema dec.(32)
		beacon_counter
		status_counter
		hex1
		hex2
		temp
		temp2			
		 
	endc
;_________________________________________________________

#define	PTT_OUT		PORTA, 2
#define	VALID_OUT	PORTB, 0
#define	VOX_IN		PORTB, 3     ;  detecta CD

;_________________________________________________________
	ORG	0x00	             ;vector de reset
	goto	main

	movlw    0x07 	; CONFIGURA PINES DEL COMPARADOR ANALOGICO COMO I/O
    	movwf    0x1F	; CMCON   ;MOVWF   0x1F; SOLO EN EL 16F628


;_________________________________________________________
;_________________________________________________________
	include	"OPTIONS.ASM"   ; Opciones de usuario
	ORG	 0x04
	include	"MODEM.ASM"	; Codigos del Modem
	include "AX25.ASM"    	; Rutinas AX-25 
	include "TIMING.ASM"  	; Rutinas de temporizacin
;_________________________________________________________
sendHeader
	movlw	OPT_CALLSIGN_DIGI
	movwf	temp

Packet_Send_Callsign
	movfw	temp
	call	Get_Option
	iorlw	0
	skpnz
	goto	Packet_Send_Type     ; H'03' H'F0'
	movwf	temp2
	incf	temp, W
	call	Get_Option
	iorlw	0
	clrc
	skpnz
	setc
 	rlf	temp2, W
	call	AX25_Send_Data
	incf	temp, F
	goto	Packet_Send_Callsign

Packet_Send_Type
	movlw	H'03'
	call	AX25_Send_Data
	movlw	H'F0'
	goto	AX25_Send_Data
;_________________________________________________________
Packet_Send_String	; Cadena de transmisin de Packet
	movfw	hex1
	call	Get_Option
	iorlw	0
	skpnz
	return
	call	AX25_Send_Data
	incf	hex1, F
	goto	Packet_Send_String
;_________________________________________________________

SendStatus		; Cadena de transmisin del text Status
	call	AX25_Send_Start
	call	sendHeader
	movlw	'>'  ; simbolo de estatus
	call 	AX25_Send_Data
	
;************** fin texto Status
	
	movlw	OPT_STATUS_OFFSET      ;Options D'6'
	call	Get_Option
	movwf	hex1
	call	Packet_Send_String
	goto	AX25_Send_End
;_________________________________________________________

SendBeacon	        ; Cadena de transmisin  del text Baliza
	call	AX25_Send_Start
	call	sendHeader
	movlw	'!'  ; simbolo de Beacon
	call 	AX25_Send_Data

;************** fin text beacom

	movlw	OPT_BEACON_OFFSET      ; Options D'5'
	call	Get_Option
	movwf	hex1
	call	Packet_Send_String
	goto	AX25_Send_End
;_________________________________________________________
BigDelay			; rutina de retardo para
	clrf	hex1		; parpadeo de LED de puesta
bigDly1	clrf 	hex2       	; en marcha.
bigDly2	decfsz  hex2, f
	goto    bigDly2
	decfsz  hex1, f
	goto	bigDly1
	return
;_________________________________________________________
main	
	call	Tone_Init	; Initialization
	call	Timing_Init
	bsf	STATUS, RP0	; Seleccin Bank 1
	bcf	PTT_OUT		; make PTT an output
	bcf	VALID_OUT	; make Valid Led an output
	bcf	STATUS, RP0	; Seleccin Bank 0
	bcf	PTT_OUT		; release PTT
	movlw	D'5'
	movwf	temp

flash	bsf	VALID_OUT	; parpadea LED al encendido
	call	BigDelay
	bcf	VALID_OUT
	call	BigDelay
	decfsz	temp, f
	goto	flash

;_________________________________________________________
mainLoop

	call	Timing_Check	; prueba timing and inputs	
	iorlw	0		; mira el resultado
	skpnz			; si es cero
	goto	mainLoop	; continua bucle
	
	
 	bsf	VALID_OUT	   	; enciende LED Valid.	
	call	BigDelay
	decfsz  beacon_counter, f  	; tiempo baliza
	goto 	bcntest
	movlw	OPT_BEACON_RATE1
	call	Get_Option
	movwf	beacon_counter		; reset cotador baliza
	bsf	PTT_OUT			; PTT ON
	call	SendBeacon		; Tx beacon packet

bcntest	
	decfsz  status_counter, f   	; tiempo satus 
	goto	nobcn
	movlw	OPT_STATUS_RATE1
	call	Get_Option
	movwf	status_counter	    	; reset status contador
	bsf	PTT_OUT			; PTT ON
	call 	SendStatus	    	; Tx status packet

nobcn
	bcf	PTT_OUT	   		; PTT OFF
	call	BigDelay   		; wait a while with valid led on
	bcf	VALID_OUT  		; apaga LED Valid.
	goto	mainLoop   		; continue loop
;_________________________________________________________
	
	END
;_________________________________________________________