; Programa original escrito por Byon Garrabant, N6BG, 
; Modificado por A.Navarro EA3CNO, Julio 2002
; Para modem TCM3105 por EB1BDM
;_________________________________________________________
;
;                   M O D E M . A S M
;_________________________________________________________
	cblock			; variables
		FLAGS		; generic flags / bits
		next_freq
		intWsave	; interrupt flags
		intSTATUSsave
		intPCLATHsave
	endc
;_________________________________________________________

#define	SENT			FLAGS, 1
#define	BANK1			H'7F'
#define	TONE_OUT		PORTB, 5

;_________________________________________________________
Timer_Interrupt
  movwf	 intWsave	;save W
  swapf	 STATUS, W	;save STATUS
  movwf	 intSTATUSsave
  movfw	 PCLATH		;save PCLATH
  movwf	 intPCLATHsave
  bcf	 STATUS, RP0	;select bank 0 (working with TMR0)
  movlw	 D'130'		; bump timer forward for
  subwf	 TMR0, F	; update TMR0 for next int
  bsf	 SENT		; ready for the next bit

timer_end
  bcf	 INTCON, T0IF		; enable TMR0 int
  movfw	 intPCLATHsave		; restore PCLATH
  movwf	 PCLATH			
  swapf	 intSTATUSsave, W	; restore STATUS
  movwf	 STATUS
  swapf	 intWsave, F		; restore W
  swapf	 intWsave, W
  retfie			; return from interrupt
;_________________________________________________________
Tone_Init
	bsf	STATUS, RP0	; Select Bank 1
	bcf	TONE_OUT	; make data an output
	bcf	STATUS, RP0	; Select Bank 0
	clrf	INTCON

Tone_Disable
	bcf	INTCON, T0IE	; disableTMR0int
	bsf	STATUS, RP0	; Select Bank 1
	movlw	b'11010111'	; divide TMR0 by 256
	movwf	OPTION_REG & BANK1	; enable TMR0
	bcf	STATUS, RP0	; Select Bank 0
	bcf	INTCON, GIE	; disable ints
	bcf	TONE_OUT	; disable audio tone
	return

Tone_Enable
	bsf	STATUS, RP0	; Select Bank 1
	movlw	b'11010011'	; div by 16
	movwf	OPTION_REG & BANK1	; enable TMR0
	bcf	STATUS, RP0	; Select Bank 0
	bsf	INTCON, T0IE	; enableTMR0int
	bsf	INTCON, GIE	; enable ints
	clrf	next_freq	; set initial freq
				; possible delay needed
	return
;_________________________________________________________
Tone_Toggle_If_No_Carry
	btfss	SENT	; wait for last bit to be sent
	goto	$-1
	bcf 	SENT	; next bit is ready
	skpnc				; if sending a 1
	return				; leave
	incf	next_freq, F		; set new
	btfsc	next_freq, 0
	bsf	TONE_OUT
	btfss	next_freq, 0
	bcf	TONE_OUT
	return
;_________________________________________________________