; Programa original escrito por Byon Garrabant, N6BG, 
; Modificado por A.Navarro EA3CNO, Julio 2002
; Para modem TCM3105 por EB1BDM
;_________________________________________________________
;
;                    T I M I N G . A S M
;_________________________________________________________
	cblock
		lastTMR0
		sub_second_timer
		quiet_timer
 		transmission_timer
	endc
;_________________________________________________________
Timing_Init
	movlw	D'1'
	movwf	beacon_counter
	movwf	status_counter
	movwf	sub_second_timer
	clrf	quiet_timer
	clrf	transmission_timer
	return

Timing_Check_Update
  btfsc	 VOX_IN		;clear quiet_timer
  clrf	 quiet_timer	;if voice activity
  movfw	 lastTMR0	;get difference from
  subwf	 TMR0, W	;last time and
  addwf	 lastTMR0, F	;add to last time
  skpc			;if no wrap
  return		;leave
  clrc		        ;prepare to update ptt history
  decfsz sub_second_timer, F  ;count down the sub seconds
  return		      ;if not zero, leave
  movlw	 D'38'			;reset the sub seconds
  movwf	 sub_second_timer	
  incf	 quiet_timer, F		;bump quiet_timer
  skpnz				;but clamp
  decf	 quiet_timer, F		;at 255
  btfsc	 VOX_IN			;clear quiet_timer
  clrf	 quiet_timer		;if voice activity
  incf	 transmission_timer, F	;inc transmission_timer
  skpnz				;but clamp
  decf	 transmission_timer, F	;to 255
  return
	
Timing_Check
  call	 Timing_Check_Update
  bnz	 Check_Done
  movlw	 OPT_RANGE_TIME		; check range time base
  call	 Get_Option
  subwf	 transmission_timer, W
  bnc	 Check_Done
  movlw	 OPT_QUIET_TIME		; check quiet time
  call	 Get_Option
  subwf	 quiet_timer, W
  bnc	 Check_Done
  clrf	 transmission_timer
  retlw	 1
  clrf	 transmission_timer

Check_Done	
  bcf	 PTT_OUT		; release PTT
  retlw	 0
;_________________________________________________________